dist: bionic
sudo: true
  #
language: c
  #
notifications:
  email: false
  #
before_install:
  #
  # Fetch the tag information for the current branch
  - git fetch origin --tags
  #
  # Publish the buildroot script folder
  - chmod +x ${TRAVIS_BUILD_DIR}/buildroot/bin/*
  - export PATH=${TRAVIS_BUILD_DIR}/buildroot/bin/:${PATH}
  #
  # Start fb X server
  - "/sbin/start-stop-daemon --start --quiet --pidfile /tmp/custom_xvfb_1.pid --make-pidfile --background --exec /usr/bin/Xvfb -- :1 -ac -screen 0 1280x1024x16"
  - sleep 3
  - export DISPLAY=:1.0
  #
install:
  #
  # Install arduino 1.8.5
  - wget http://downloads.arduino.cc/arduino-1.8.9-linux64.tar.xz
  - tar xf arduino-1.8.9-linux64.tar.xz
  - sudo mv arduino-1.8.9 /usr/local/share/arduino
  - ln -s /usr/local/share/arduino/arduino ${TRAVIS_BUILD_DIR}/buildroot/bin/arduino
  #
  # Install: LiquidCrystal_I2C library
  - git clone https://github.com/kiyoshigawa/LiquidCrystal_I2C.git
  - mv LiquidCrystal_I2C/LiquidCrystal_I2C /usr/local/share/arduino/libraries/LiquidCrystal_I2C
  #
  # Install: LiquidTWI2 library
  - git clone https://github.com/lincomatic/LiquidTWI2.git
  - sudo mv LiquidTWI2 /usr/local/share/arduino/libraries/LiquidTWI2
  #
  # Install: Monochrome Graphics Library for LCDs and OLEDs
  - git clone https://github.com/olikraus/U8glib_Arduino.git
  - sudo mv U8glib_Arduino /usr/local/share/arduino/libraries/U8glib
  #
  # Install: L6470 Stepper Motor Driver library
  # - git clone https://github.com/ameyer/Arduino-L6470.git
  # - sudo mv Arduino-L6470/L6470 /usr/local/share/arduino/libraries/L6470
  #
  # Install: TMC26X Stepper Motor Controller library
  # - git clone https://github.com/trinamic/TMC26XStepper.git
  # - sudo mv TMC26XStepper /usr/local/share/arduino/libraries/TMC26XStepper
  #
  # Install: TMC2130 Stepper Motor Controller library
  - git clone https://github.com/teemuatlut/TMC2130Stepper.git
  - sudo mv TMC2130Stepper /usr/local/share/arduino/libraries/TMC2130Stepper
  #
  # Install: TMC2208 Stepper Motor Controller library
  - git clone https://github.com/teemuatlut/TMC2208Stepper.git
  - sudo mv TMC2208Stepper /usr/local/share/arduino/libraries/TMC2208Stepper
  #
  # Install: Adafruit Neopixel library
  - git clone https://github.com/adafruit/Adafruit_NeoPixel.git
  - sudo mv Adafruit_NeoPixel /usr/local/share/arduino/libraries/Adafruit_NeoPixel
  #
before_script:
  #
  # Change current working directory to the build dir
  - cd ${TRAVIS_BUILD_DIR}
  #
  # Generate custom version include
  - generate_version_header_for_marlin ${TRAVIS_BUILD_DIR}/Marlin
  - cat ${TRAVIS_BUILD_DIR}/Marlin/_Version.h
  #
script:
  #
  # Backup Configuration.h, Configuration_adv.h, and pins_RAMPS.h
  #
  - cp Marlin/Configuration.h Marlin/Configuration.h.backup
  - cp Marlin/Configuration_adv.h Marlin/Configuration_adv.h.backup
  - cp Marlin/pins_RAMPS.h Marlin/pins_RAMPS.h.backup
  #
  # Build with the default configurations
  #
  - build_marlin
  #
  # Test 2 extruders (one MAX6675) and heated bed on basic RAMPS 1.4
  # Test a "Fix Mounted" Probe with Safe Homing, some arc options,
  # linear bed leveling, M48, leveling debug, and firmware retraction.
  #
  - opt_set MOTHERBOARD BOARD_RAMPS_14_EEB
  - opt_set EXTRUDERS 2
  - opt_set TEMP_SENSOR_0 -2
  - opt_set TEMP_SENSOR_1 1
  - opt_set TEMP_SENSOR_BED 1
  - opt_set POWER_SUPPLY 1
  - opt_enable PIDTEMPBED FIX_MOUNTED_PROBE Z_SAFE_HOMING
  - opt_enable REPRAP_DISCOUNT_SMART_CONTROLLER SDSUPPORT EEPROM_SETTINGS PINS_DEBUGGING
  - opt_enable BLINKM PCA9632 RGB_LED NEOPIXEL_LED AUTO_POWER_CONTROL NOZZLE_PARK_FEATURE FILAMENT_RUNOUT_SENSOR
  - opt_enable AUTO_BED_LEVELING_LINEAR Z_MIN_PROBE_REPEATABILITY_TEST DEBUG_LEVELING_FEATURE SKEW_CORRECTION SKEW_CORRECTION_FOR_Z SKEW_CORRECTION_GCODE
  - opt_enable_adv ARC_P_CIRCLES ADVANCED_PAUSE_FEATURE CNC_WORKSPACE_PLANES CNC_COORDINATE_SYSTEMS POWER_LOSS_RECOVERY POWER_LOSS_PIN POWER_LOSS_STATE
  - opt_enable_adv FWRETRACT MAX7219_DEBUG LED_CONTROL_MENU CASE_LIGHT_ENABLE CASE_LIGHT_USE_NEOPIXEL CODEPENDENT_XY_HOMING
  - opt_set GRID_MAX_POINTS_X 16
  - opt_set_adv FANMUX0_PIN 53
  - build_marlin
  #
  # Test a probeless build of AUTO_BED_LEVELING_UBL, with lots of extruders
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_AZTEEG_X3_PRO
  - opt_set EXTRUDERS 5
  - opt_set TEMP_SENSOR_1 1
  - opt_set TEMP_SENSOR_2 5
  - opt_set TEMP_SENSOR_3 20
  - opt_set TEMP_SENSOR_4 999
  - opt_set TEMP_SENSOR_BED 1
  - opt_enable AUTO_BED_LEVELING_UBL RESTORE_LEVELING_AFTER_G28 DEBUG_LEVELING_FEATURE G26_MESH_EDITING ENABLE_LEVELING_FADE_HEIGHT SKEW_CORRECTION
  - opt_enable EEPROM_SETTINGS EEPROM_CHITCHAT REPRAP_DISCOUNT_FULL_GRAPHIC_SMART_CONTROLLER
  - opt_enable_adv CUSTOM_USER_MENUS I2C_POSITION_ENCODERS BABYSTEPPING BABYSTEP_XY LIN_ADVANCE NANODLP_Z_SYNC QUICK_HOME JUNCTION_DEVIATION MAX7219_DEBUG
  - opt_set_adv MAX7219_ROTATE 270
  - build_marlin
  #
  # Add a Sled Z Probe, use UBL Cartesian moves, use Japanese language
  #
  - opt_enable Z_PROBE_SLED SKEW_CORRECTION SKEW_CORRECTION_FOR_Z SKEW_CORRECTION_GCODE S_CURVE_ACCELERATION
  - opt_set LCD_LANGUAGE kana_utf8
  - opt_disable SEGMENT_LEVELED_MOVES
  - opt_enable_adv BABYSTEP_ZPROBE_OFFSET DOUBLECLICK_FOR_Z_BABYSTEPPING
  - build_marlin
  #
  # Test a Servo Probe
  # ...with AUTO_BED_LEVELING_3POINT, DEBUG_LEVELING_FEATURE, EEPROM_SETTINGS, EEPROM_CHITCHAT, EXTENDED_CAPABILITIES_REPORT, and AUTO_REPORT_TEMPERATURES
  #
  - restore_configs
  - opt_enable NUM_SERVOS Z_PROBE_SERVO_NR Z_SERVO_ANGLES DEACTIVATE_SERVOS_AFTER_MOVE
  - opt_set NUM_SERVOS 1
  - opt_enable AUTO_BED_LEVELING_3POINT DEBUG_LEVELING_FEATURE EEPROM_SETTINGS EEPROM_CHITCHAT
  - opt_enable_adv NO_VOLUMETRICS EXTENDED_CAPABILITIES_REPORT AUTO_REPORT_TEMPERATURES AUTOTEMP G38_PROBE_TARGET
  - build_marlin
  #
  # Test MESH_BED_LEVELING feature, with LCD
  #
  - restore_configs
  - opt_enable MESH_BED_LEVELING G26_MESH_EDITING MESH_G28_REST_ORIGIN LCD_BED_LEVELING ULTIMAKERCONTROLLER
  - build_marlin
  #
  # Test MINIRAMBO for PWM_MOTOR_CURRENT
  #      PROBE_MANUALLY feature, with LCD support,
  #      ULTIMAKERCONTROLLER, FILAMENT_LCD_DISPLAY, FILAMENT_WIDTH_SENSOR,
  #      PRINTCOUNTER, NOZZLE_PARK_FEATURE, NOZZLE_CLEAN_FEATURE, PCA9632,
  #      Z_DUAL_ENDSTOPS, BEZIER_CURVE_SUPPORT, EXPERIMENTAL_I2CBUS,
  #      ADVANCED_PAUSE_FEATURE, ADVANCED_PAUSE_CONTINUOUS_PURGE, PARK_HEAD_ON_PAUSE, LCD_INFO_MENU, M114_DETAIL
  #      EEPROM_SETTINGS, EEPROM_CHITCHAT, M100_FREE_MEMORY_WATCHER,
  #      INCH_MODE_SUPPORT, TEMPERATURE_UNITS_SUPPORT
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_MINIRAMBO
  - opt_enable PROBE_MANUALLY AUTO_BED_LEVELING_BILINEAR G26_MESH_EDITING LCD_BED_LEVELING ULTIMAKERCONTROLLER
  - opt_enable EEPROM_SETTINGS EEPROM_CHITCHAT M100_FREE_MEMORY_WATCHER M100_FREE_MEMORY_DUMPER M100_FREE_MEMORY_CORRUPTOR INCH_MODE_SUPPORT TEMPERATURE_UNITS_SUPPORT
  - opt_enable ULTIMAKERCONTROLLER SDSUPPORT
  - opt_enable PRINTCOUNTER NOZZLE_PARK_FEATURE NOZZLE_CLEAN_FEATURE PCA9632
  - opt_enable_adv BEZIER_CURVE_SUPPORT EXPERIMENTAL_I2CBUS
  - opt_enable_adv ADVANCED_PAUSE_FEATURE ADVANCED_PAUSE_CONTINUOUS_PURGE FILAMENT_LOAD_UNLOAD_GCODES PARK_HEAD_ON_PAUSE LCD_INFO_MENU M114_DETAIL
  - opt_set_adv PWM_MOTOR_CURRENT {1300,1300,1250}
  - opt_set_adv I2C_SLAVE_ADDRESS 63
  - build_marlin
  #
  # Mixing Extruder with 5 steppers, Cyrillic
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_AZTEEG_X3_PRO
  - opt_enable MIXING_EXTRUDER CR10_STOCKDISPLAY
  - opt_set MIXING_STEPPERS 5
  - opt_set LCD_LANGUAGE ru
  - build_marlin
  #
  # Test DUAL_X_CARRIAGE
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_RUMBA
  - opt_set EXTRUDERS 2
  - opt_set TEMP_SENSOR_1 1
  - opt_enable USE_XMAX_PLUG
  - opt_enable_adv DUAL_X_CARRIAGE
  - build_marlin
  #
  # Test SPEAKER with BOARD_BQ_ZUM_MEGA_3D and BQ_LCD_SMART_CONTROLLER
  #
  #- restore_configs
  #- opt_set MOTHERBOARD BOARD_BQ_ZUM_MEGA_3D
  #- opt_set LCD_FEEDBACK_FREQUENCY_DURATION_MS 10
  #- opt_set LCD_FEEDBACK_FREQUENCY_HZ 100
  #- opt_enable BQ_LCD_SMART_CONTROLLER SPEAKER
  #
  # Test SWITCHING_EXTRUDER
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_RUMBA
  - opt_set EXTRUDERS 2
  - opt_enable NUM_SERVOS
  - opt_set NUM_SERVOS 1
  - opt_enable SWITCHING_EXTRUDER ULTIMAKERCONTROLLER
  - build_marlin
  #
  # Enable COREXY
  #
  #- restore_configs
  #- opt_enable COREXY
  #- build_marlin
  #
  # Test many less common options
  #
  - restore_configs
  - opt_enable COREYX
  - opt_set_adv FAN_MIN_PWM 50
  - opt_set_adv FAN_KICKSTART_TIME 100
  - opt_set_adv XY_FREQUENCY_LIMIT  15
  - opt_enable_adv SHOW_TEMP_ADC_VALUES HOME_Y_BEFORE_X EMERGENCY_PARSER FAN_KICKSTART_TIME
  - opt_enable_adv ABORT_ON_ENDSTOP_HIT_FEATURE_ENABLED ADVANCED_OK
  - opt_enable_adv VOLUMETRIC_DEFAULT_ON NO_WORKSPACE_OFFSETS ACTION_ON_KILL
  - opt_enable_adv EXTRA_FAN_SPEED FWERETRACT Z_DUAL_STEPPER_DRIVERS Z_DUAL_ENDSTOPS
  - opt_enable_adv MENU_ADDAUTOSTART SDCARD_SORT_ALPHA
  - opt_enable REPRAP_DISCOUNT_SMART_CONTROLLER BABYSTEPPING DAC_MOTOR_CURRENT_DEFAULT
  - opt_enable FILAMENT_LCD_DISPLAY FILAMENT_WIDTH_SENSOR
  - opt_enable ENDSTOP_INTERRUPTS_FEATURE FAN_SOFT_PWM SDSUPPORT
  - opt_enable USE_XMAX_PLUG
  - build_marlin
  #
  ######## Other Standard LCD/Panels ##############
  #
  # ULTRA_LCD
  #
  #- restore_configs
  #- opt_enable ULTRA_LCD
  #- build_marlin
  #
  # DOGLCD
  #
  #- restore_configs
  #- opt_enable DOGLCD
  #- build_marlin
  #
  # MAKRPANEL
  # Needs to use Melzi and Sanguino hardware
  #
  #- restore_configs
  #- opt_enable MAKRPANEL
  #- build_marlin
  #
  # REPRAP_DISCOUNT_SMART_CONTROLLER, SDSUPPORT, BABYSTEPPING, RIGIDBOARD_V2, and DAC_MOTOR_CURRENT_DEFAULT
  #
  #- restore_configs
  #- opt_set MOTHERBOARD BOARD_RIGIDBOARD_V2
  #- opt_enable REPRAP_DISCOUNT_SMART_CONTROLLER SDSUPPORT BABYSTEPPING DAC_MOTOR_CURRENT_DEFAULT
  #- build_marlin
  # #
  # G3D_PANEL with SDCARD_SORT_ALPHA and STATUS_MESSAGE_SCROLLING
  #
  #- restore_configs
  #- opt_enable G3D_PANEL SDSUPPORT
  #- opt_enable_adv SDCARD_SORT_ALPHA STATUS_MESSAGE_SCROLLING SCROLL_LONG_FILENAMES
  #- opt_set_adv SDSORT_GCODE true
  #- opt_set_adv SDSORT_USES_RAM true
  #- opt_set_adv SDSORT_USES_STACK true
  #- opt_set_adv SDSORT_CACHE_NAMES true
  #- build_marlin
  #
  # REPRAP_DISCOUNT_FULL_GRAPHIC_SMART_CONTROLLER with LIGHTWEIGHT_UI
  #
  - restore_configs
  - opt_enable REPRAP_DISCOUNT_FULL_GRAPHIC_SMART_CONTROLLER SDSUPPORT
  - opt_enable_adv SDCARD_SORT_ALPHA STATUS_MESSAGE_SCROLLING SCROLL_LONG_FILENAMES LIGHTWEIGHT_UI
  - opt_set_adv SDSORT_GCODE true
  - opt_set_adv SDSORT_USES_RAM true
  - opt_set_adv SDSORT_USES_STACK true
  - opt_set_adv SDSORT_CACHE_NAMES true
  - build_marlin
  #
  # REPRAPWORLD_KEYPAD
  #
  # Cant find configuration details to get it to compile
  #- restore_configs
  #- opt_enable ULTRA_LCD REPRAPWORLD_KEYPAD REPRAPWORLD_KEYPAD_MOVE_STEP
  #- build_marlin
  #
  # RA_CONTROL_PANEL
  #
  #- restore_configs
  #- opt_enable RA_CONTROL_PANEL PINS_DEBUGGING
  #- build_marlin
  #
  ######## I2C LCD/PANELS ##############
  #
  # !!!ATTENTION!!!
  # Most I2C configurations are failing at the moment because they require
  # a different Liquid Crystal library "LiquidTWI2".
  #
  # LCD_SAINSMART_I2C_1602
  #
  #- restore_configs
  #- opt_enable LCD_SAINSMART_I2C_1602
  #- build_marlin
  #
  # LCD_I2C_PANELOLU2
  #
  #- restore_configs
  #- opt_enable LCD_I2C_PANELOLU2
  #- build_marlin
  #
  # LCD_I2C_VIKI
  #
  #- restore_configs
  #- opt_enable LCD_I2C_VIKI
  #- build_marlin
  #
  # LCM1602
  #
  #- restore_configs
  #- opt_enable LCM1602
  #- build_marlin
  #
  # Language files test with REPRAP_DISCOUNT_FULL_GRAPHIC_SMART_CONTROLLER
  #
  #- restore_configs
  #- opt_enable REPRAP_DISCOUNT_FULL_GRAPHIC_SMART_CONTROLLER SDSUPPORT
  #- for lang in an bg ca zh_CN zh_TW cz da de el el-gr en es eu fi fr gl hr it jp-kana ko_KR nl pl pt pt-br ru sk tr uk test; do opt_set LCD_LANGUAGE $lang; echo "compile with language $lang ..."; build_marlin
  #
  #- restore_configs
  #- opt_enable REPRAP_DISCOUNT_SMART_CONTROLLER SDSUPPORT
  #- for lang in an bg ca zh_CN zh_TW cz da de el el-gr en es eu fi fr gl hr it jp-kana ko_KR nl pl pt pt-br ru sk tr uk test; do opt_set LCD_LANGUAGE $lang; echo "compile with language $lang ..."; build_marlin
  #
  #
  ######## Example Configurations ##############
  #
  # BQ Hephestos 2
  #- restore_configs
  #- use_example_configs Hephestos_2
  #- build_marlin
  #
  # Delta Config (generic) + ABL bilinear + PROBE_MANUALLY
  - use_example_configs delta/generic
  - opt_enable REPRAP_DISCOUNT_SMART_CONTROLLER DELTA_CALIBRATION_MENU AUTO_BED_LEVELING_BILINEAR PROBE_MANUALLY
  - build_marlin
  #
  # Delta Config (generic) + UBL + ALLEN_KEY + OLED_PANEL_TINYBOY2 + EEPROM_SETTINGS
  #
  - use_example_configs delta/generic
  - opt_enable AUTO_BED_LEVELING_UBL RESTORE_LEVELING_AFTER_G28 Z_PROBE_ALLEN_KEY EEPROM_SETTINGS EEPROM_CHITCHAT
  - opt_enable OLED_PANEL_TINYBOY2 MESH_EDIT_GFX_OVERLAY
  - build_marlin
  #
  # Delta Config (FLSUN AC because it's complex)
  #
  - use_example_configs delta/FLSUN/auto_calibrate
  - build_marlin
  #
  # Makibox Config  need to check board type for Teensy++ 2.0
  #
  #- use_example_configs makibox
  #- build_marlin
  #
  # SCARA with TMC2130
  #
  - use_example_configs SCARA
  - opt_enable AUTO_BED_LEVELING_BILINEAR FIX_MOUNTED_PROBE USE_ZMIN_PLUG EEPROM_SETTINGS EEPROM_CHITCHAT ULTIMAKERCONTROLLER
  - opt_set X_DRIVER_TYPE TMC2130
  - opt_set Y_DRIVER_TYPE TMC2130
  - opt_set Z_DRIVER_TYPE TMC2130
  - opt_set E0_DRIVER_TYPE TMC2130
  - opt_enable_adv MONITOR_DRIVER_STATUS STEALTHCHOP HYBRID_THRESHOLD SENSORLESS_HOMING
  - build_marlin
  #
  # TMC2208 Config
  #
  - restore_configs
  - opt_set X_DRIVER_TYPE TMC2208
  - opt_set Y_DRIVER_TYPE TMC2208
  - opt_set Z_DRIVER_TYPE TMC2208
  - opt_set E0_DRIVER_TYPE TMC2208
  - opt_enable_adv MONITOR_DRIVER_STATUS STEALTHCHOP HYBRID_THRESHOLD TMC_DEBUG
  - build_marlin
  #
  # tvrrug Config need to check board type for sanguino atmega644p
  #
  #- use_example_configs tvrrug/Round2
  #- build_marlin
  #
  #
  ######## Board Types #############
  #
  # To be added in nightly test branch
  #
